package WebFlow.ContextManager; 

import WebFlow.*; 
import WebFlow.event.*; 
import WebFlow.RemoteFile.*;
import WebFlow.hashtable.*;
import WebFlow.ContextManager.ContextManagerPackage.*;
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.util.*;

public class ClientR{


   public static void main(String args[])
   {
      try
      {
         //  Create ORB
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            ORB orb = ORB.init(args, props);

         //  Connect to the master server


         if(args.length !=1) {
           System.out.println("Usage:");
           System.out.println("   WebFlow.JobService.Client url");
           System.out.println("     url - url to the master's IOR");
           System.exit(1);
	 }    

         String masterURL = args[0] ; 
    
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 

         ref = getIORFromURL(masterURL); 

         System.out.println("REF: "+ref); 

         obj = orb.string_to_object(ref); 

         if(obj == null)
              throw new RuntimeException(); 

         WebFlowContext ws =  WebFlowContextHelper.narrow(obj);
         System.out.println("Clinet: got master "+ws);
  
         if(ws == null)
               throw new RuntimeException(); 
         
         System.out.println("attach module"); 

          org.omg.CORBA.Object p1 = ws.addNewModule("RemoteFile");  
          RemoteFile remotefile = RemoteFileHelper.narrow(p1);
          org.omg.CORBA.Object p2 = ws.addNewModule("SaveContext");  
          SaveContext saveContext  = SaveContextHelper.narrow(p2);
          org.omg.CORBA.Object p3 = ws.addNewModule("ContextManager");
          ContextManager cm = ContextManagerHelper.narrow(p3);
          org.omg.CORBA.Object p4 = ws.addNewModule("ContextData");
          ContextData cd = ContextDataHelper.narrow(p4);
   
          remotefile.test();
          saveContext.test();

          System.out.println("test cm");
          cm.test();
          System.out.println("cm OK");

     boolean status;

     System.out.println("add user context");
     String user = "user1";
     //WebFlowContext uc = cm.createGatewayContext(ws,user);
     WebFlowContext uc=null;
     try {
        uc = WebFlowContextHelper.narrow(ws.addNewContext(user));
        cd = ContextDataHelper.narrow(uc.addNewModule("ContextData"));
     } catch (Exception e) {System.out.println("EXCEPTION "+e);}
        System.out.println("user created");
        System.out.println(uc.getObjectID());

        cm.init(uc,p2,p1);
        System.out.println("cm initialized");

      
        System.out.println("\nrestore user contextData");
        saveContext.restoreContextData(uc,"/tmp/");

        System.out.println("\nrestore project contexts");
        cm.restoreChildContexts(uc);

        System.out.println("set current contexts");
        cm.setCurrentContexts();

        if(cm.isCurrentProblem()) {
          System.out.println(cm.getCurrentProblemProperty("Name")); 
	} 
        if(cm.isCurrentSession()) {
          System.out.println(cm.getCurrentSessionProperty("Name")); 
	} 
        if(cm.isCurrentApplication()) {
          System.out.println(cm.getCurrentApplicationProperty("Name")); 
	} 

        System.out.println("check context data");
        System.out.println("currentChild "+cm.getContextData(uc,"CurrentChild"));
        System.out.println("Children "+cm.getContextData(uc,"Children"));
        
        System.out.println("set project01 as the current problem");
        cm.setCurrentProblem("project01");
        System.out.println(cm.getCurrentProblemProperty("ContextName")); 
        
      

        System.out.println("done");

      } catch(COMM_FAILURE ex) {
        System.out.println("Command_Error: "+ex); 

        System.err.println(ex.getMessage()); 
        ex.printStackTrace(); 
        System.exit(1); 
       }  
   } 

   static public String getIORFromURL(String url) {

   System.out.println("Slave WebFlow is getting IOR from url:"+url); 
   String masterServerIOR =""; 
   String thisLine = null ; 

   // Open the URL for reading 
 
   try{
        URL u = new URL(url); 

        // now turn the URL into a DataInputStream

        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());

          while((thisLine = theHTML.readLine()) != null){ 
             masterServerIOR += thisLine ; 
          } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e); 
     }
    return masterServerIOR ; 
  }
}





